package de.joethei.hs.java2.tests;

import de.joethei.hs.java2.praktikum.praktikum4.KlausurenServer;
import org.apache.log4j.Logger;
import org.apache.log4j.Priority;
import org.apache.log4j.spi.LoggingEvent;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.ArgumentCaptor;
import org.mockito.Captor;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.powermock.modules.junit4.PowerMockRunner;

import java.net.Socket;

import static org.junit.Assert.*;

@RunWith(PowerMockRunner.class)
public class KlausurenServerTest3 {

    @InjectMocks
    private KlausurenServer klausurenServer = new KlausurenServer(6770);

    @Mock
    private Socket socket;

    TestAppender appender = new TestAppender();

    @Captor
    ArgumentCaptor<LoggingEvent> logCaptor;

    @Test
    public void ioException() {

        appender.setThreshold(Priority.INFO);
        Logger.getLogger("KlausurenServer").addAppender(appender);

        KlausurenServer klausurenServer = new KlausurenServer(6770);

        assertTrue(appender.messages.contains("Fehler beim Server beenden"));
        assertFalse(appender.messages.contains("Fehler beim erstellen des Sockets"));
        assertFalse(appender.messages.contains("Hallo Welt"));


    }

    @Test
    public void getLogger() {
        assertEquals(Logger.getLogger("KlausurenServer"), KlausurenServer.getLogger());
    }
}